unless defined?(JF::SaveAllInstances)
   UI.menu.add_item("Import Instances") { JF::SaveAllInstances.import() }
   UI.add_context_menu_handler do  |menu|
      model = Sketchup.active_model
      if model.selection.size == 1 && model.selection.first.class == Sketchup::ComponentInstance
         menu.add_item("Save All Instances") { JF::SaveAllInstances.main() }
      end
   end
end

module JF
   module SaveAllInstances

      def self.main
         SKETCHUP_CONSOLE.clear
         model = Sketchup.active_model
         ins = model.selection[0]
         iname = ins.definition.name
         guid = ins.definition.guid
         # Go over model, get positions
         #instances = model.definitions[iname].instances.length
         instances = find_instances(guid, IDENTITY, Sketchup.active_model.entities)
         export(ins, instances)
      end

      def self.find_instances(guid, tr, ents, data = [])
         ents.each do |ent|
            if ent.class == Sketchup::ComponentInstance
               if ent.definition.guid == guid
                  data << tr * ent.transformation
               else
                  find_instances(guid, tr * ent.transformation, ent.definition.entities, data)
               end
            end
            if ent.class == Sketchup::Group
               find_instances(guid, tr * ent.transformation, ent.entities, data)
            end
         end
         data
      end

      def self.export(ins, instances)
         model = Sketchup.active_model
         path = Sketchup.active_model.path
         path = path.gsub('\\', '/')
         path = File.dirname(path)
         ins.definition.save_as(File.join(path, ins.definition.name + ".skp"))
         out = File.open(File.join(path, ins.definition.name + ".txt"), "w") do |f|
            instances.each { |tr| f.puts tr.to_a.join(",")}
         end
      end

      def self.import
         model = Sketchup.active_model
         file = UI.openpanel
         filename = File.basename(file, ".skp")
         dir = File.dirname(file)
         txtfile = File.join(dir, filename + ".txt")
         cdef = model.definitions.load(file)
         File.foreach(txtfile) do |line|
            line.strip!
            tr = Geom::Transformation.new(line.split(",").map{|e| e.to_f})
            model.entities.add_instance(cdef, tr)
         end
      end

   end
end
